// vim: foldmethod=marker

flock.dialog = {
    // waking up is never so great
    // as when it is your fault
    // you can have my dreams
}

flock.dialog.prompt = function (aProps) {/*{{{*/
    var dlg = new flock.dialog.Dialog(aProps);
    dlg.open();
    return dlg.result;
};/*}}}*/


flock.dialog.confirm = function (aMsg) {
    var dlg = new flock.dialog.Dialog({
        message: aMsg,
        modal: true,
        title: "Please Confirm Your Action"
    });
    dlg.open();
    return (dlg.result.accept == true);
}

flock.dialog.Dialog = function (aProps) {
    flock.xul.Node.call(this, null, aProps);
}
dojo.inherits(flock.dialog.Dialog, flock.xul.Node);
dojo.lang.extend(flock.dialog.Dialog, {
    spec: "chrome://browser/content/flock/common/dialog.xul",
    title: 'Dialog',
    name: "Dialog",
    modal: true,
    close: false,
    titlebar: true,
    result: null,
    message: null,
    validators: null,
    fields: null,
    centerscreen: true,
    get params() {/*{{{*/
        var out = ["chrome"];
        if (this.modal) out.push("modal");
        if (this.titlebar) out.push("titlebar");
        if (this.centerscreen) out.push("centerscreen");
        return out;
    },/*}}}*/
    buttons: ["accept","cancel"],
    open: function () {/*{{{*/
        if (this.modal) {
            window.openDialog(this.spec, this.name, this.params, this);
        } else {
            this.mWindow = window.openDialog(this.spec, this.name, 
                                             this.params, this);
        }
    },/*}}}*/
    close: function () {/*{{{*/
        if (!this.modal) {
            this.mWindow.close();
        }
    },/*}}}*/
    onLoad: function (aEvt) {/*{{{*/
        this.mWindow = aEvt.currentTarget;
        this.mDialog = this.mWindow.document.getElementById('flock_dialog');
        this.mMessage = this.mWindow.document.getElementById('message');
        this.mForm = this.mWindow.document.getElementById('form');
        this.mDialog.buttons = this.buttons.join(",");
        if (this.message) {
            this.mMessage.value = this.message;
            flock.xul.show(this.mMessage);
        }
        if (this.validators) {
            this.mForm.validators = this.validators;
        }
        if (this.fields) {
            for (var i = 0; i < this.fields.length; ++i) {
                this.mForm.addField(this.fields[i]);
            }
        }
    },/*}}}*/
    onDialogAccept: function (aEvt) {/*{{{*/
        if (!this.mForm.validate()) {
            this.mWindow.sizeToContent();
            return false;
        }
        this.result = this.mForm.values;
        this.result.accept = true;
        return true;
    },/*}}}*/
    onDialogCancel: function (aEvt) {/*{{{*/
        return true;
    },/*}}}*/
    onDialogHelp: function (aEvt) {/*{{{*/

    },/*}}}*/
    onDialogDisclosure: function (aEvt) {/*{{{*/

    },/*}}}*/
    onOverflow: function (aEvt) {/*{{{*/
        this.mWindow.sizeToContent();
    },/*}}}*/
});

flock.dialog.Prompt = function (aProps) {
    


}
