// vim: foldmethod=marker

//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

function getL10nStringBundle () {
    var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
    var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
    var stringBundle = stringBundleService.createBundle("chrome://flock/locale/common/loginDetect.properties", localeService.getApplicationLocale());
    return stringBundle;
}


var LoginCheckerManager = {
    mLocation: "",
    mCheckers: new Array(),
    mConfigureButton: null,
    register: function (aChecker) {
        this.mCheckers.push(aChecker);
    },
    onProgressChange : function(aProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress){},
    onStatusChange : function(aProgress, aRequest, aStatus, aMessage){},
    onSecurityChange : function(a,b,c){},
    onLinkIconAvailable : function(a){},
    onStateChange : function(aProgress, aRequest, aStateFlags, aStatus) {
        if(aStateFlags &  Components.interfaces.nsIWebProgressListener.STATE_STOP &&
            aStateFlags &  Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW) {
            this.mLocation = aRequest.name;
            if(!this.mLocation) return;
            for(var i=0;i<this.mCheckers.length;++i) {
                var checker = this.mCheckers[i];
                checker.setLocation(this.mLocation);
                if(checker.isNewlyLoggedIn()) {
                    this.promptForSetup(checker);
                }
            }
        }
    },

    onLocationChange : function(aProgress, aRequest, aLocation) {
    },
    getCookieString: function(aLocation) {
        var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
        var cservice = Components.classes["@mozilla.org/cookieService;1"].getService().QueryInterface(Components.interfaces.nsICookieService);
        uri.spec = aLocation;

        result = cservice.getCookieString(uri, null);
        dump(result + "\n");
        if (!result) result = "";
        return result;
    },
    clickListener: function() {
        LoginCheckerManager.mConfigureButton.removeEventListener('click',LoginCheckerManager.clickListener,false);
        LoginCheckerManager.mChecker.doAction();
        gBrowser.hideMessage(gBrowser.selectedBrowser, "top");
    },
    promptForSetup: function(aChecker) {
        var dontAsk = "flock.logindetect." + aChecker.shortName + ".dontask";
        var message = aChecker.getMessage();

        if(flock_getBoolPref(dontAsk)) return;

        var ps = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);

        var check = {value: false}; 

        var stringBundle = getL10nStringBundle();
        var rv = ps.confirmEx(
            window, 
            stringBundle.GetStringFromName("flock.common.detect.title").replace(/%1/g,aChecker.name), 
            message,
            ps.BUTTON_TITLE_IS_STRING * ps.BUTTON_POS_0 + ps.BUTTON_TITLE_CANCEL * ps.BUTTON_POS_1,
            stringBundle.GetStringFromName("flock.common.detect.configure"), 
            null, 
            null, 
            stringBundle.GetStringFromName("flock.common.detect.dontask"), 
            check);

        if(rv==0) {
           aChecker.doAction();
        }

        flock_setBoolPref(dontAsk,check.value);
/*
        flock_setBoolPref(dontAsk,check.value);
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
        check = {value: false}; 
        prompts.alertCheck(window, "Setup " + aChecker.name + " Service", message, "Don't ask again", check);
        // do something with check.value;
        gBrowser.showMessage(gBrowser.selectedBrowser, "chrome://browser/skin/Info.png",
                            message, "Configure", null, null, "",
                            "top", true, null);

        var tabBox = gBrowser.mTabBox;
        var tabPanels = tabBox.getElementsByTagName('tabpanels')[0];
        var browserMessage = tabPanels.getElementsByTagName('browsermessage')[0];
        var configureButton = browserMessage._buttonElement;
        this.mConfigureButton = configureButton;
        this.mChecker = aChecker;
        configureButton.addEventListener('click', this.clickListener, false);
*/
    },
    init: function () {
        function doInit() {
            try {
                gBrowser.addProgressListener(LoginCheckerManager);
            }
            catch(e) {
            }
        }
        window.setTimeout(doInit, 0);
        top.removeEventListener('load', LoginCheckerManager.init, false);
    },
}

// this is the basic structure of a listener
/*

LoginChecker.prototype = {
    setLocation: function(aLocation) { },
    isNewlyLoggedIn: function() { },
    doAction: function() {},
    getMessage: function() {},
}

*/

var FlickrLoginChecker = {
    STATE_INIT: 0,
    STATE_AT_LOGIN_PAGE: 1,
    STATE_JUST_LOGGED_IN: 2,
    mState: 0,
    mLocation: "",
    shortName: "flickr",
    name: "Flickr",
    // we must make the message localizable

    getMessage: function() {
        var stringBundle = getL10nStringBundle();
        return stringBundle.GetStringFromName("flock.common.detect.photo.login").replace(/%1/g, this.name);
    },
    getRedirectMessage: function() {
        var stringBundle = getL10nStringBundle();
        return stringBundle.GetStringFromName("flock.common.detect.redirect").replace(/%1/g, this.name);
    },
    setLocation: function(aLocation) { 
        //dump("setting location " + aLocation + " " + this.mState + "\n");
        switch(this.mState) {
            case this.STATE_INIT:
                if( 
                    aLocation.match(/^http:\/\/flickr\.com\/signin\/flickr\//) ||
                    aLocation.match(/^http:\/\/\w+\.flickr\.com\/signin\/flickr\//) ||
                    aLocation.match(/^https:\/\/login\.yahoo\.com\/config\/validate/)
                ) {
                    this.mState = this.STATE_AT_LOGIN_PAGE;
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_AT_LOGIN_PAGE:
                var apimgr = Components.classes['@flock.com/photo-api-manager;1?'].getService(Components.interfaces.flockIPhotoAPIManager);
                var  api = apimgr.getAPIFromShortname("flickr");
                if(api.isLoggedIn) {
                    this.mState = this.STATE_INIT;
                }
                else if(
                    aLocation.match(/^http:\/\/flickr\.com\//) ||
                    aLocation.match(/^http:\/\/www\.flickr\.com\//)
                ) {
                    var cookieString = LoginCheckerManager.getCookieString(aLocation);
                    if(
                        cookieString.match(/cookie_epass/) ||
                        cookieString.match(/cookie_session/)
                        ) {
                        this.mState = this.STATE_JUST_LOGGED_IN;
                    }
                    else {
                        this.mState = this.STATE_INIT;
                    }
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_JUST_LOGGED_IN:
                this.mState = this.STATE_INIT;
            break;
        }
        this.mLocation = aLocation;
    },
    isNewlyLoggedIn: function() { 
        return (this.mState==this.STATE_JUST_LOGGED_IN);
    },
    doAction: function() {
        window.openDialog("chrome://browser/content/flock/photo/photoAccountWizard.xul", "wiz", "modal,centerscreen", "flickr");
        var apimgr = Components.classes['@flock.com/photo-api-manager;1?'].getService(Components.interfaces.flockIPhotoAPIManager);
        var  api = apimgr.getAPIFromShortname("flickr");
        if(api.isLoggedIn) {
            flock_topbarSelectById('flock_PhotoBrowseTopbarBroadcaster');
        }
    },
}

var PhotobucketLoginChecker = {
    STATE_INIT: 0,
    STATE_AT_LOGIN_PAGE: 1,
    STATE_JUST_LOGGED_IN: 2,
    mState: 0,
    mLocation: "",
    shortName: "photobucket",
    name: "Photobucket",
    getMessage: function() {
        var stringBundle = getL10nStringBundle();
        return stringBundle.GetStringFromName("flock.common.detect.photo.login").replace(/%1/g, this.name);
    },
    getRedirectMessage: function() {
        var stringBundle = getL10nStringBundle();
        return stringBundle.GetStringFromName("flock.common.detect.redirect").replace(/%1/g, this.name);
    },
    setLocation: function(aLocation) { 
        dump("setting location " + aLocation + " " + this.mState + "\n");
        switch(this.mState) {
            case this.STATE_INIT:
                if( 
                    aLocation.match(/^http:\/\/photobucket\.com\/login\.php$/)
                ) {
                    this.mState = this.STATE_AT_LOGIN_PAGE;
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_AT_LOGIN_PAGE:
                var apimgr = Components.classes['@flock.com/photo-api-manager;1?'].getService(Components.interfaces.flockIPhotoAPIManager);
                var  api = apimgr.getAPIFromShortname("photobucket");
                if(api.isLoggedIn) {
                    this.mState = this.STATE_INIT;
                }
                else if(
                    aLocation.match(/^http:\/\/\w+\.photobucket\.com\/albums/)
                ) {
                    this.mState = this.STATE_JUST_LOGGED_IN;
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_JUST_LOGGED_IN:
                this.mState = this.STATE_INIT;
            break;
        }
        this.mLocation = aLocation;
    },
    isNewlyLoggedIn: function() { 
        return (this.mState==this.STATE_JUST_LOGGED_IN);
    },
    doAction: function() { 
        window.openDialog("chrome://browser/content/flock/photo/photoAccountWizard.xul", "wiz", "modal,centerscreen", "photobucket");
        var apimgr = Components.classes['@flock.com/photo-api-manager;1?'].getService(Components.interfaces.flockIPhotoAPIManager);
        var  api = apimgr.getAPIFromShortname("photobucket");
        if(api.isLoggedIn) {
            flock_topbarSelectById('flock_PhotoBrowseTopbarBroadcaster');
        }
    },
}

var WordpressLoginChecker = {
    STATE_INIT: 0,
    STATE_AT_LOGIN_PAGE: 1,
    STATE_JUST_LOGGED_IN: 2,
    mState: 0,
    mLocation: "",
    shortName: "wordpress",
    name: "Wordpress",
    getMessage: function() {
        var stringBundle = getL10nStringBundle();
        return stringBundle.GetStringFromName("flock.common.detect.blog.login").replace(/%1/g, this.name);
    },
    setLocation: function(aLocation) { 
        dump("setting location " + aLocation + " " + this.mState + "\n");
        switch(this.mState) {
            case this.STATE_INIT:
                if( 
                    aLocation.match(/wordpress\.com/)
                ) {
                  // Make sure the user is not already logged in
                  // (if yes, we won't popup the notification)
                  var cookieString = LoginCheckerManager.getCookieString(aLocation);
                  if(!cookieString.match("loggedin"))
                    this.mState = this.STATE_AT_LOGIN_PAGE;
                  else
                    this.mState = this.STATE_INIT;
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_AT_LOGIN_PAGE:
                var cookieString = LoginCheckerManager.getCookieString(aLocation);
                var configured = false; 
                var blogService = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-blog'].getService(Components.interfaces['flockIBlogService']);
                accounts = blogService.getAccountList().split("|");
                if (accounts != "") {
                  for (i=0; i<accounts.length; i++) {
                    //dump(accounts[i]+"\n");
                    var account = blogService.getAccount(accounts[i]);
                    var domain = account.pwhost;
                    if (domain.match(/\.wordpress\.com/))
                      configured = true;
                  }
                }
                if(cookieString.match("loggedin") && (!configured)) {
                    this.mState = this.STATE_JUST_LOGGED_IN;
                }
                else {
                    this.mState = this.STATE_INIT;
                }
/*
                if( aLocation.match(/^https:\/\/\w+\.wordpress\.com\/wp-admin\//)) 
                {
                    this.mState = this.STATE_JUST_LOGGED_IN;
                }
                else if (aLocation.match(/\w+\.wordpress\.com\//))
                {
                }
*/
            break;
            case this.STATE_JUST_LOGGED_IN:
                this.mState = this.STATE_INIT;
            break;
        }
        this.mLocation = aLocation;
    },
    isNewlyLoggedIn: function() { 
        return (this.mState==this.STATE_JUST_LOGGED_IN);
    },
    doAction: function() { 
        this.mLocation.match(/^(https:\/\/.+?)\//);
        //window.openDialog("chrome://browser/content/flock/blog/blogAccountWizard.xul", "accountWizard", "modal,centerscreen", RegExp.$1);
        window.openDialog("chrome://browser/content/flock/blog/blogAccountWizard.xul", "accountWizard", "modal,centerscreen");
    },
}

var LivejournalLoginChecker = {
    STATE_INIT: 0,
    STATE_AT_LOGIN_PAGE: 1,
    STATE_JUST_LOGGED_IN: 2,
    mState: 0,
    mLocation: "",
    shortName: "livejournal",
    name: "Live Journal",
    getMessage: function() {
        var stringBundle = getL10nStringBundle();
        return stringBundle.GetStringFromName("flock.common.detect.blog.login").replace(/%1/g, this.name);
    },
    setLocation: function(aLocation) { 
        dump("setting location " + aLocation + " " + this.mState + "\n");
        switch(this.mState) {
            case this.STATE_INIT:


                if( 
                    aLocation.match(/livejournal\.com/)
                ) {
                  // Make sure the user is not already logged in
                  // (if yes, we won't popup the notification)
                  var cookieString = LoginCheckerManager.getCookieString(aLocation);
                  if(!cookieString.match("ljloggedin"))
                    this.mState = this.STATE_AT_LOGIN_PAGE;
                  else
                    this.mState = this.STATE_INIT;
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_AT_LOGIN_PAGE:
                var cookieString = LoginCheckerManager.getCookieString(aLocation);
                if(cookieString.match("ljloggedin"))
                {
                  var configured = false; 
                  var blogService = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-blog'].getService(Components.interfaces['flockIBlogService']);
                  accounts = blogService.getAccountList().split("|");
                  if (accounts != "") {
                    for (i=0; i<accounts.length; i++) {
                      //dump(accounts[i]+"\n");
                      var account = blogService.getAccount(accounts[i]);
                      var domain = account.pwhost;
                      if (domain.match(/\.livejournal\.com/))
                        configured = true;
                    }
                  }
                  if (!configured)
                    this.mState = this.STATE_JUST_LOGGED_IN;
                  else
                    this.mState = this.STATE_INIT;
                }
                else if (aLocation.match(/\.livejournal\.com/))
                {
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_JUST_LOGGED_IN:
                this.mState = this.STATE_INIT;
            break;
        }
        this.mLocation = aLocation;
    },
    isNewlyLoggedIn: function() { 

      return (this.mState==this.STATE_JUST_LOGGED_IN);
    },
    doAction: function() { 
        // this.mLocation.match(/^(https:\/\/.+?)\//);
        window.openDialog("chrome://browser/content/flock/blog/blogAccountWizard.xul", "accountWizard", "modal,centerscreen"); //, RegExp.$1);
    },
}

var BloggerLoginChecker = {
    STATE_INIT: 0,
    STATE_AT_LOGIN_PAGE: 1,
    STATE_JUST_LOGGED_IN: 2,
    mState: 0,
    mLocation: "",
    shortName: "blogger",
    name: "Blogger",
    getMessage: function() {
        var stringBundle = getL10nStringBundle();
        return stringBundle.GetStringFromName("flock.common.detect.blog.login").replace(/%1/g, this.name);
    },
    setLocation: function(aLocation) { 
        dump("setting location " + aLocation + " " + this.mState + "\n");
        switch(this.mState) {
            case this.STATE_INIT:
                if( 
                    aLocation.match(/blogger\.com/)
                ) {
                    this.mState = this.STATE_AT_LOGIN_PAGE;
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_AT_LOGIN_PAGE:
                if( aLocation.match(/http:\/\/www\.blogger\.com\/home/))
                {
                  var configured = false; 
                  var blogService = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-blog'].getService(Components.interfaces['flockIBlogService']);
                  accounts = blogService.getAccountList().split("|");
                  if (accounts != "") {
                    for (i=0; i<accounts.length; i++) {
                      var account = blogService.getAccount(accounts[i]);
                      var domain = account.pwhost;
                      if (domain.match(/\.blogspot\.com/))
                        configured = true;
                    }
                  }
                  if (!configured)
                    this.mState = this.STATE_JUST_LOGGED_IN;
                  else
                    this.mState = this.STATE_INIT;
                }
                else if (aLocation.match(/\.blogger\.com/))
                {
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_JUST_LOGGED_IN:
                this.mState = this.STATE_INIT;
            break;
        }
        this.mLocation = aLocation;
    },
    isNewlyLoggedIn: function() { 
        return (this.mState==this.STATE_JUST_LOGGED_IN);
    },
    doAction: function() { 
        // this.mLocation.match(/^(https:\/\/.+?)\//);
        window.openDialog("chrome://browser/content/flock/blog/blogAccountWizard.xul", "accountWizard", "modal,centerscreen"); //, RegExp.$1);
    },
}

var TypepadLoginChecker = {
    STATE_INIT: 0,
    STATE_AT_LOGIN_PAGE: 1,
    STATE_JUST_LOGGED_IN: 2,
    mState: 0,
    mLocation: "",
    shortName: "typepad",
    name: "Typepad",
    getMessage: function() {
        var stringBundle = getL10nStringBundle();
        return stringBundle.GetStringFromName("flock.common.detect.blog.login").replace(/%1/g, this.name);
    },
    setLocation: function(aLocation) { 
        dump("setting location " + aLocation + " " + this.mState + "\n");
        switch(this.mState) {
            case this.STATE_INIT:
                if( 
                    aLocation.match(/typepad\.com/)
                ) {
                    this.mState = this.STATE_AT_LOGIN_PAGE;
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_AT_LOGIN_PAGE:
                if( aLocation.match(/https:\/\/www\.typepad\.com\/t\/app/))
                {
                  var configured = false; 
                  var blogService = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-blog'].getService(Components.interfaces['flockIBlogService']);
                  accounts = blogService.getAccountList().split("|");
                  if (accounts != "") {
                    for (i=0; i<accounts.length; i++) {
                      //dump(accounts[i]+"\n");
                      var account = blogService.getAccount(accounts[i]);
                      var domain = account.pwhost;
                      if (domain.match(/\.typepad\.com/))
                        configured = true;
                    }
                  }
                  if (!configured)
                    this.mState = this.STATE_JUST_LOGGED_IN;
                  else
                    this.mState = this.STATE_INIT;
                }
                else if (aLocation.match(/\.typepad\.com/))
                {
                }
                else {
                    this.mState = this.STATE_INIT;
                }
            break;
            case this.STATE_JUST_LOGGED_IN:
                this.mState = this.STATE_INIT;
            break;
        }
        this.mLocation = aLocation;
    },
    isNewlyLoggedIn: function() { 
        return (this.mState==this.STATE_JUST_LOGGED_IN);
    },
    doAction: function() { 
        // this.mLocation.match(/^(https:\/\/.+?)\//);
        window.openDialog("chrome://browser/content/flock/blog/blogAccountWizard.xul", "accountWizard", "modal,centerscreen"); //, RegExp.$1);
    },
}

var DeliciousLoginChecker = {
  STATE_INIT: 0,
  STATE_AT_LOGIN_PAGE: 1,
  STATE_JUST_LOGGED_IN: 2,
  mState: 0,
  mLocation: "",
  shortName: "delicious",
  name: "Del.icio.us",
  getMessage: function() {
        var stringBundle = getL10nStringBundle();
        return stringBundle.GetStringFromName("flock.common.detect.fav.login").replace(/%1/g, this.name);
  },
  setLocation: function(aLocation) { 
    dump("setting location " + aLocation + " " + this.mState + "\n");
    switch(this.mState) {
      case this.STATE_INIT:
        if( aLocation.match(/del\.icio\.us\/login/)) {
          this.mState = this.STATE_AT_LOGIN_PAGE;
        }
        else {
          this.mState = this.STATE_INIT;
        }
        break;
      case this.STATE_AT_LOGIN_PAGE:
        var cookieString = LoginCheckerManager.getCookieString(aLocation);
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].
           getService(Components.interfaces.nsIPrefBranch);
        var service = prefs.getCharPref("flock.favorites.webservice.id");
        if(cookieString.match("_user") && (service == "")) {
          this.mState = this.STATE_JUST_LOGGED_IN;
        }
        else {
          this.mState = this.STATE_INIT;
        }
        break;
      case this.STATE_JUST_LOGGED_IN:
        this.mState = this.STATE_INIT;
        break;
    }
    this.mLocation = aLocation;
  },
  isNewlyLoggedIn: function() { 
    return (this.mState==this.STATE_JUST_LOGGED_IN);
  },
  doAction: function() { 
    window.openDialog('chrome://browser/content/flock/favorites/favoritesSharing.xul', 'Favorites Sharing', 'modal');
  },
}

var ShadowsLoginChecker = {
  STATE_INIT: 0,
  STATE_AT_LOGIN_PAGE: 1,
  STATE_JUST_LOGGED_IN: 2,
  mState: 0,
  mLocation: "",
  shortName: "shadows",
  name: "shadows",
  getMessage: function() {
        var stringBundle = getL10nStringBundle();
        return stringBundle.GetStringFromName("flock.common.detect.fav.login").replace(/%1/g, this.name);
  },
  setLocation: function(aLocation) { 
    dump("setting location " + aLocation + " " + this.mState + "\n");
    switch(this.mState) {
      case this.STATE_INIT:
        if( aLocation.match(/shadows\.com\/Security\/login\.rails/)) {
          this.mState = this.STATE_AT_LOGIN_PAGE;
        }
        else {
          this.mState = this.STATE_INIT;
        }
        break;
      case this.STATE_AT_LOGIN_PAGE:
        var cookieString = LoginCheckerManager.getCookieString(aLocation);
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].
           getService(Components.interfaces.nsIPrefBranch);
        var service = prefs.getCharPref("flock.favorites.webservice.id");
        dump("cookieString: "+cookieString+"\n");
        if(cookieString.match("RememberLogin") && (service == "")) {
          this.mState = this.STATE_JUST_LOGGED_IN;
        }
        else {
          this.mState = this.STATE_INIT;
        }
        break;
      case this.STATE_JUST_LOGGED_IN:
        this.mState = this.STATE_INIT;
        break;
    }
    this.mLocation = aLocation;
  },
  isNewlyLoggedIn: function() { 
    return (this.mState==this.STATE_JUST_LOGGED_IN);
  },
  doAction: function() { 
    window.openDialog('chrome://browser/content/flock/favorites/favoritesSharing.xul', 'Favorites Sharing', 'modal');
  },
}


// Photo sharing services
LoginCheckerManager.register(FlickrLoginChecker);
LoginCheckerManager.register(PhotobucketLoginChecker);
// Blogging services
LoginCheckerManager.register(WordpressLoginChecker);
LoginCheckerManager.register(LivejournalLoginChecker);
LoginCheckerManager.register(BloggerLoginChecker);
LoginCheckerManager.register(TypepadLoginChecker);
// Favorites sharing services
LoginCheckerManager.register(DeliciousLoginChecker);
LoginCheckerManager.register(ShadowsLoginChecker);

top.addEventListener('load', LoginCheckerManager.init, false);
