// vim: foldmethod=marker

// dnd handler for favorites tree
var favoriteDNDObserver = new flock.dnd.Observer({
    mTree: null, /* we will fill this in on init */
    onDragStart: function (aEvent, aXferData, aDragAction, aXferTarget) {/*{{{*/
    try {
        //var tree = aEvent.currentTarget;

        //var selectedItems = flock_getTreeSelectionFromDrag(aEvent, tree, ["url", "name"], {filterChildren: false});
        var selectedItems = this.mTree.getSelected(['url','name']);
        if(!selectedItems) return false;

        var dataSet = new TransferDataSet();
        for (var i = 0; i < selectedItems.length; ++i) {
            var fav = new flock.favorites.Favorite(selectedItems[i]);
            var data = new flock.xpcom.Transferable(fav);
            dataSet.push(data);
        }
        aXferData.data = dataSet;
        
        if (aEvent.ctrlKey)
            aDragAction.action = Components.interfaces.nsIDragService.DRAGDROP_ACTION_COPY;
    } catch (e) { dd(e); }
    },/*}}}*/
    onDragEnter: function (aEvent, aDragSession) {/*{{{*/
        // Grab the data to be dropped
        var droppedData = new DNDTransferSet({
            supportedFlavours: ["text/x-moz-url", "text/unicode"],
            dragSession: aDragSession,
            isDebug: false
        });
        dragData = droppedData.getDataAs("url");
        if (this.mTree.mNode.ref == "http://flock.com/rdf#FavoritesRoot") {
            for (var i = 0; i < dragData.length; ++i) {
                var aVal = dragData[i];
                var fav = flock.favorites.getFavorite(aVal);
                if (fav) this.mTree.validDrop = false;
                return;
            }
        }
        this.mTree.validDrop = true;
    },/*}}}*/
})

var gAutoScrollOriginal;
var gBrowser;
function onLoad(aEvt) {/*{{{*/
    var mostRecent = flock.browser.mostRecentNavigator.gBrowser
    var browserIndex = mostRecent.getBrowserIndexForDocument(document);
    gBrowser = mostRecent.getBrowserAtIndex(browserIndex);

    
    init_manager();
    init_left();
    init_right();
    init_commandHack();

    if (!gAutoScrollOriginal) {
        gAutoScrollOriginal = gBrowser.getAttribute('autoscrollenabled');
    }
    gBrowser.setAttribute('autoscroll','false');
    //XXX('TITTLLLEEE');
    //XXX(flock.browser.currentBrowser.contentTitle);
    //XXX('focused', document.commandDispatcher.focusedElement);
}/*}}}*/

function onUnload(aEvt) {/*{{{*/
    if (gAutoScrollOriginal) {
        gBrowser.setAttribute('autoscroll', gAutoScrollOriginal);
    } else {
        gBrowser.removeAttribute('autoscroll');
    }
}/*}}}*/


function init_commandHack() {/*{{{*/
    //dojo.event.connect(window, 'onfocus', function () {
    //    XXX('window', 'onfocus');
    //    document.commandDispatcher.updateCommands('focus');
    //});
    //dojo.event.connect(window, 'onselect', function () {
    //    XXX('window', 'onselect');
    //    document.commandDispatcher.updateCommands('select');
    //});
    //window.focus();
}/*}}}*/

function init_manager() {
    var collectionListBox = $('collectionListBox');
    var favTree = $('flock_favoriteView');

    var managerController = new CommandController({
        cmd_find: function () {/*{{{*/
            $('favoritesManagerSearchbox').focus();
        },/*}}}*/

        // XXX - BAD UI -- the following could either go here
        // or in the favoritesController... right now we are not
        // being consistant.  MAKE THESE CONSISTENT!  - ja

        cmd_selectAllFavs: function () { /*{{{*/
            favTree.view.selection.selectAll();
        },/*}}}*/
        cmd_clearSelection: function () { /*{{{*/
            favTree.view.selection.clearSelection();
        },/*}}}*/ 
        cmd_collectionCreate: function () {/*{{{*/
            // create empty collection
            flock.favorites.createCollection();
        },/*}}}*/
    });

    window.controllers.appendController(managerController);
    // XXX - need to remove the managerController on unload


}

function init_left() {
    var collectionListBox = $('collectionListBox');
    var favTree = $('flock_favoriteView');
    
    // Controller Stuff
    // XXX DEBUG

    var collectionIsEditable = function () {/*{{{*/
        if (!collectionListBox.selectedItem) return false;
        return (collectionListBox.selectedItem.getAttribute('editable') != "false");
    };/*}}}*/
    var collectionHasFeeds = function () {/*{{{*/
        /* disable hasFeeds */
        return false;

        if (!collectionIsEditable) return false;
        return (collectionListBox.selectedItem.getAttribute('hasFeeds') == "true");
    }/*}}}*/
    

    // should probably stop using the big command updater and do specific 
    // small updates
    var collectionController = new CommandController({
        mNode: collectionListBox,
        mLibraryItem: $('flock_collectionLibrary'),
        isDebug: false,
        debugCommands: ["cmd_delete"],
        debugFromCommandset: "flock_collectionCommands",
        cmd_delete: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () { goDoCommand('cmd_collectionRemove'); }
        },/*}}}*/
        cmd_handleBackspace: function () { flock.command('cmd_collectionRemove'); },
        cmd_forceDelete: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () { goDoCommand('cmd_collectionForceRemove'); }
        },/*}}}*/
        cmd_collectionRemove: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.removeCollection(selected.id);
                this.mNode.selectedIndex = 0;
            }
        },/*}}}*/
        cmd_collectionForceRemove: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.removeCollection(selected.id, true);
                this.mNode.selectedIndex = 0;
            }
        },/*}}}*/
        cmd_collectionRename: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function (aEvt) {
                XXX('GOT AN EVVENET', aEvt);
                dd(aEvt);
                var selected = this.mNode.selectedItem;
                flock.favorites.renameCollection(selected.id);
            }
        },/*}}}*/
        cmd_collectionProperties: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.editCollection(selected.id);
            }
        },/*}}}*/
        cmd_collectionOpenInTabs: {/*{{{*/
            isEnabled: collectionIsEditable,
            exec: function () {
                var selected = this.mNode.selectedItem
                flock.favorites.openCollectionInTabs(selected.id);
            }
        },/*}}}*/
        cmd_collectionViewFeeds: {/*{{{*/
            isEnabled: collectionHasFeeds,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.viewFeedsForCollection(selected.id);
            }
        },/*}}}*/
        cmd_collectionViewFeedsInTab: {/*{{{*/
            isEnabled: collectionHasFeeds,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.viewFeedsForCollection(selected.id, 'tab');
            }
        },/*}}}*/
        cmd_collectionViewFeedsInWindow: {/*{{{*/
            isEnabled: collectionHasFeeds,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.viewFeedsForCollection(selected.id, 'window');
            }
        },/*}}}*/
        cmd_collectionRefreshFeeds: {/*{{{*/
            isEnabled: collectionHasFeeds,
            exec: function () {
                var selected = this.mNode.selectedItem;
                flock.favorites.refreshFeedsForCollection(selected.id);
            }
        },/*}}}*/
    });
    
    collectionListBox.controllers.appendController(collectionController);
    
    // Popup Stuffs
    var collectionContext = new flock.xul.Popup($('collectionContext'), {/*{{{*/
        isDebug: true,
        onPopupShowing: function (aEvt) {
            flock_updateCommandset($('flock_collectionCommands'));
        },
    });/*}}}*/
    collectionContext.attach();
    

    // Collection Observer
    var collectionListBoxObserver = {/*{{{*/
        favTree: favTree,
        getSupportedFlavours: function (aFlavourSet) {
            aFlavourSet.appendFlavour("text/x-moz-url");
            aFlavourSet.appendFlavour("text/unicode");
            aFlavourSet.appendFlavour("application/x-moz-file");
        },
        canDropOnChild: function (aEvent, aTarget, aDragSession, aBoolVal) {
            var canDrop = (aTarget.getAttribute('dropable') != "false");
            aBoolVal.value = canDrop;
        },
        onContextClickOnChild: function (aEvent, aTarget) {
            flock_updateCommandset($('flock_collectionCommands'));
        },
        onSelectOnChild: function (aEvent, aTarget) {
            var newRef = aTarget.getAttribute('collection');
            if (newRef == "NC:HistoryRoot")
               this.favTree.setAttribute('datasources', 'rdf:history rdf:flock-favorites rdf:files rdf:localsearch');
            else
               this.favTree.setAttribute('datasources', 'rdf:flock-favorites rdf:history rdf:files rdf:localsearch');
            this.favTree.setAttribute('ref', newRef);
            flock_updateCommandset($('flock_collectionCommands'));
            flock_updateCommandset($('flock_favoriteCommands'));
        },
        onDropOnChild: function (aEvent, aTarget, aXferData, aDragSession) {
            var data = new DNDTransferSet({
                supportedFlavours: [
                    "text/x-moz-url", 
                    "text/unicode",
                    "application/x-moz-file"
                ],
                dragSession: aDragSession,
                isDebug: true
            });
            var ar = data.getDataAs("url");
            flock.favorites.addItemsToCollection(ar, aTarget.resource);
        },
        onDrop: function (aEvent, aTarget, aXferData, aDragSession) {
            var data = new DNDTransferSet({
                supportedFlavours: [
                    "text/x-moz-url", 
                    "text/unicode",
                    "application/x-moz-file"
                ],
                dragSession: aDragSession,
                isDebug: false
            });
            var ar = data.getDataAs("url");
            flock.favorites.createCollectionFrom(ar);
        },
    };/*}}}*/
    collectionListBox.addObserver(collectionListBoxObserver);
 
    // Select the initial item
    var qs = flock.browser.parseQuery(gBrowser.currentURI.spec);
    var items = collectionListBox.childNodes;
    if (qs.collection) {
        for (var i = 0; i < items.length; ++i) {
            var item = items[i];
            if (item.getAttribute('collection') == qs.collection) {
                collectionListBox.selectedItem = item;
            }
        }
    }
    else {
        collectionListBox.selectedIndex = 0;
    }
    
    
}


// Initializing the right side.
function init_right() {
    var tree = $('flock_favoriteView');
    var flockFavorites = flock_getFavoritesService();
    var RDF = flock_getRDFService();

    //// XXX andy: REFACTOR ME
    //var feedsSelected = function () {[>{{{<]
    //    var selectedItems = flock_getTreeSelection(tree, ["url"]);
    //    for (var i = 0; i < selectedItems.length; ++i) {
    //        var item = selectedItems[i];
    //        if (flock.favorites.isFeed(item['url'])) return true;
    //        if (flock.favorites.favoriteHasFeeds(item['url'])) return true;
    //    }
    //    return false;    
    //};[>}}}<]
    
    treeController = new CommandController({
        isDebug: false,
        debugCommands: ["cmd_return", "cmd_delete"],
        debugFromCommandset: 'flock_favoriteCommands',
        cmd_delete: function () { goDoCommand('cmd_favoriteMgrRemove'); },
        cmd_handleBackspace: function () { flock.command('cmd_favoriteMgrRemove'); },
        cmd_forceDelete: function () { /*{{{*/
            goDoCommand('cmd_favoriteMgrForceRemove'); 
        },/*}}}*/
        cmd_selectAll: function () { flock.command('cmd_favoriteMgrSelectAll'); },
        cmd_return: function () { goDoCommand('cmd_favoriteMgrOpen'); },
        cmd_copy: function () { flock.command('cmd_favoriteMgrCopy'); },
        cmd_favoriteMgrRemove: {/*{{{*/
            isEnabled: function () {
                return (tree.ref != "NC:HistoryRoot");
            },
            exec: function () {
                var selected = favoritesTree.selectedItems;
                var _ = flock.xpcom.stringBundler("chrome://flock/locale/favorites/favoritesManager.properties");
        
                var message =  _("flock.favorites.manager.confirm1");
                if (selected.length > 1) {
                    if (tree.ref == "http://flock.com/rdf#FavoritesRoot") {
                        message = _("flock.favorites.manager.confirm2");
                    }
                    else {
                        message = _("flock.favorites.manager.confirm3");
                    }
                } 
                else {
                    if (tree.ref == "http://flock.com/rdf#FavoritesRoot") {
                        message = _("flock.favorites.manager.confirm4");
                    }
                    else {
                        message = _("flock.favorites.manager.confirm5");
                    }
                }
                
                var rv = flock.dialog.confirm(message);
                if (!rv) return
                
                goDoCommand('cmd_favoriteMgrForceRemove');
            }
        },/*}}}*/ 
        cmd_favoriteMgrCopy: {/*{{{*/
            isEnabled: function () {
                return (tree.view.selection.count > 0);
            },
            exec: function () {
                // XXX andy: these should do bookmarkclipboarditems, too 
                var selectedItems = favoritesTree.selectedItems;
                var unicode = "";
                var html = "";
                selectedItems.forEach(function (aVal) {
                    var fav = flock.favorites.getFavorite({
                        "url": aVal['url'],
                        "name": aVal['name'],
                    });
                    var favData = fav.toTransferData();
                    unicode += favData['text/unicode'] + "\n";
                    html += favData['text/html'];
                });
                var trans = new flock.xpcom.Transferable({
                    "text/unicode": unicode,
                    "text/html": html
                });
                
                // XXX andy: we could use a dataset like below, but... 
                //           for some reason firefox does not
                //           so I am going to follow their lead...
                //           also, the other way looks prettier when pasted
                //           into textboxes
                //var dataSet = new TransferDataSet();
                //for (var i = 0; i < selectedItems.length; ++i) {
                //    var item = selectedItems[i];
                //    var data = new TransferData();
                //    data.addDataForFlavour("text/x-moz-url", item['url']+"\n"+item['name']);
                //    data.addDataForFlavour("text/html",      "<a href='"+item['url']+"'>"+item['name']+"</a>");
                //    data.addDataForFlavour("text/unicode",   item['url']);
                //    dataSet.push(data);
                //}
                //var trans = dataSet;
                flock.xpcom.setClipboardData(trans);
            }
        },/*}}}*/
        cmd_favoriteMgrSelectAll: function () {
            tree.view.selection.selectAll();
        },
        cmd_favoriteMgrForceRemove: {/*{{{*/
            isEnabled: function () {
                return (tree.ref != "NC:HistoryRoot");
            },
            exec: function () {
                XXX('MEEE');
                var selected = favoritesTree.selectedItems;
                // var selected = flock_getTreeSelection(tree, ["url"]);
                // attempted optimization
                
                tree.view.selection.selectEventsSuppressed = true;
                tree.database.beginUpdateBatch();
                for (var i = 0; i < selected.length; ++i) {
                    var row = selected[i];
                    if (row.parentIndex != -1) {
                        // remove from a favorite
                        flock.favorites.removeItemFromParent(
                            row['url'], 
                            tree.builder.getResourceAtIndex(row.parentIndex)
                        );
                    }
                    else {
                        if (tree.ref == "http://flock.com/rdf#FavoritesRoot") {
                            // remove from library
                            flock.favorites.removeItemFromParent(row['url']);
                        }
                        else {
                            flock.favorites.removeItemFromParent(row['url'], tree.ref);
                        }
                    }
                }
                tree.database.endUpdateBatch();
                tree.view.selection.selectEventsSuppressed = false;
            }
        },/*}}}*/ 
        cmd_favoriteMgrRename: function () { /*{{{*/
            var selected = favoritesTree.selectedItems;
            //var selected = flock_getTreeSelection(tree, ['url', 'name']);
            flock.favorites.renameItem({
                url: selected[0]['url'],
                name: selected[0]['name']
            });
        },/*}}}*/
        cmd_favoriteMgrProperties: function () {/*{{{*/
            var selected = favoritesTree.selectedItems;
            if (selected.length>1) {
                var items = [];
                for (var i=0; i<selected.length; i++) {
                    items.push( selected[i]['url']);
                }
                flock.favorites.editMultipleItems( items );
            } else {
                flock.favorites.editItem( {url:selected[0]['url']} );
            }
        },/*}}}*/
        cmd_favoriteMgrOpen: function () { /*{{{*/
            var selected = favoritesTree.selectedItems;
            //var selected = flock_getTreeSelection(tree, ['url']);
            if (flock.favorites.isFeed(selected[0]['url'])) {
                flock.browser.openFeeds([selected[0]['url']]);
            }
            else {
                flock.browser.open(selected[0]['url']);
            }
        },/*}}}*/
        cmd_favoriteMgrOpenInTab: function () { /*{{{*/
            var selected = favoritesTree.selectedItems;
            //var selected = flock_getTreeSelection(tree, ['url']);
            if (flock.favorites.isFeed(selected[0]['url'])) {
                flock.browser.openFeeds([selected[0]['url']], 'tab');
            }
            else {
                flock.browser.open(selected[0]['url'], 'tab');
            }
        },/*}}}*/
        cmd_favoriteMgrOpenInWindow: function () { /*{{{*/
            var selected = favoritesTree.selectedItems;
            //var selected = flock_getTreeSelection(tree, ['url']);
            if (flock.favorites.isFeed(selected[0]['url'])) {
                flock.browser.openFeeds([selected[0]['url']], 'window');
            }
            else {
                flock.browser.open(selected[0]['url'], 'window');
            }
        },/*}}}*/
        cmd_favoriteMgrOpenAllInTabs: function () {/*{{{*/
            var selected = favoritesTree.selectedItems;
            //var selected = flock_getTreeSelection(tree, ['url']);
            for (var i = 0; i < selected.length; ++i) {
                if (flock.favorites.isFeed(selected[i]['url'])) {
                    flock.browser.openFeeds([selected[i]['url']], 'tab');
                }
                else {
                    flock.browser.open(selected[i]['url'], 'tab');
                }
            }
        },/*}}}*/
        cmd_collectionCreate: function () {/*{{{*/
            flock.favorites.createCollection();
            /// XXX - upon creating a collection if any favorites are selected 
            /// they should be added to the new collection
        },/*}}}*/
        cmd_favoriteMgrViewFeeds: {/*{{{*/
            isEnabled: function () { return favoritesTree.feedsSelected; },
            exec: function () {
                var selected = favoritesTree.selectedItems;
                // var selected = flock_getTreeSelection(tree, ['url']);
                var feeds = selected.map(function (aVal) {
                    return aVal['url'];
                });
                flock.favorites.viewFeeds(feeds);
            }
        },/*}}}*/
        cmd_favoriteMgrViewFeedsInTab: {/*{{{*/
            isEnabled: function () { return favoritesTree.feedsSelected; },
            exec: function () {
                var selected = favoritesTree.selectedItems;
                // var selected = flock_getTreeSelection(tree, ['url']);
                var feeds = selected.map(function (aVal) {
                    return aVal['url'];
                });
                flock.favorites.viewFeeds(feeds, 'tab');
            }
        },/*}}}*/
        cmd_favoriteMgrViewFeedsInWindow: {/*{{{*/
            isEnabled: function () { return favoritesTree.feedsSelected; },
            exec: function () {
                var selected = favoritesTree.selectedItems;
                //var selected = flock_getTreeSelection(tree, ['url']);
                var feeds = selected.map(function (aVal) {
                    return aVal['url'];
                });
                flock.favorites.viewFeeds(feeds, 'window');
            }
        },/*}}}*/
        cmd_favoriteMgrRefreshFeeds: {/*{{{*/
            isEnabled: function () { return favoritesTree.feedsSelected; },
            exec: function () {
                var selected = favoritesTree.selectedItems;
                var feeds = selected.map(function (aVal) {
                    return aVal['url'];
                });
                flock.favorites.refreshFeeds(feeds);
            }
        },/*}}}*/
    });
    // Add all the controllers to the right places/*{{{*/
    tree.controllers.appendController(treeController);
    /*}}}*/

    // Dispatch Clicks/*{{{*/
    var favoritesTreeClicker = new flock.xul.TreeClicker(tree, {
        isDebug: false,
    });
    favoritesTreeClicker.attach();/*}}}*/

    // rdf tree
    var favoritesTree = new flock.xul.RDFTree(tree, {
        isDebug: true,
        validDrop: true,
        // the checks
        isEditable: function (aResource) {/*{{{*/
            return true;
        },/*}}}*/
        
        get feedsSelected() {/*{{{*/
            if (!this.selectedItems) {
                this.selectedItems = this.getSelected(['url']);
            }
            for (var i = 0; i < this.selectedItems.length; ++i) {
                var item = this.selectedItems[i];
                XXX('ITEM', item['url']);
                if (flock.favorites.isFeed(item['url'])) return true;
                if (flock.favorites.favoriteHasFeeds(item['url'])) return true;
                XXX('no?');
            }
            return false;    
        },/*}}}*/
        clearDragData: function () {/*{{{*/
            XXX('clearingDragData');
            this.dragData = null;
            this.newDragData = true;
            
            this.dragProps = {};
        },/*}}}*/
        // nsIXULTreeBuilderObserver overrides
        canDrop: function (aIndex, aOrientation) {/*{{{*/
            // Cannot drop on things yet
            if (aOrientation == this.DROP_ON) return false;
            if (!this.validDrop) return false;            
            return true;
        },/*}}}*/
        onDrop: function (aRow, aOrientation) {/*{{{*/
            var endParent = flock_getRDFResource(this.mNode.ref);

            //var dropIndex = aRow + aOrientation;
            
            // Get drag session
            var dragSession = flock_getDragSession();
            if (!dragSession) {
                XXX('No drag session');
                return;
            }

            // Get dropped data
            var droppedData = new DNDTransferSet({
                supportedFlavours: ["text/x-moz-url", "text/unicode", "application/x-moz-file"],
                dragSession: dragSession,
                isDebug: false
            });

            var data = droppedData.getDataAs("url");
            var lastIdx = null;
            for (var i = 0; i < data.length; ++i) {
                this.mNode.database.beginUpdateBatch();
                var droppedItem = data[i];
                dd(droppedItem);
                
                // first, ensure that the item is added
                if (flock.favorites.isFeed(droppedItem.url)) {
                    droppedItem = flock.favorites.getOrCreateFeed({
                        url: droppedItem.url, 
                        name: droppedItem.name
                    });
                }
                else {
                    droppedItem = flock.favorites.getOrCreateFavorite({
                        url: droppedItem.url, 
                        name: droppedItem.name
                    });
                }
                
                // Alright, we are going to handle the drop, time to
                // figure out where we are actually dropping it
                var rowIndex = null;
                if (rowIndex == null) {
                    rowIndex = aRow;
                }
                
                
                var isInParent = flock.favorites.isItemInParent(droppedItem, endParent);
                if (!isInParent) {
                    droppedItem.rowIndex = -1;
                } else {
                    droppedItem.rowIndex = flock.favorites.getIndexInCollection(droppedItem, endParent);
                    droppedItem.rowIndex--;
                }
                
                
                if (lastIdx == null) {
                    var adjustedIndex = rowIndex;
                    XXX('DROP',  adjustedIndex, 'NO LAST IDX');
                    adjustedIndex += (aOrientation == this.DROP_BEFORE) ? 0 : 1;
                    XXX('DROP', adjustedIndex, 'ORIENT BEFORE?', (aOrientation == this.DROP_BEFORE));
                    adjustedIndex += (rowIndex > droppedItem.rowIndex) ? -1 : 0;
                    XXX('DROP', adjustedIndex, 'FROM BEFORE?', (rowIndex > droppedItem.rowIndex));
                }
                else {
                    var adjustedIndex = (rowIndex > droppedItem.rowIndex) ? lastIdx : lastIdx + 1;
                    XXX('DROP',  adjustedIndex, 'LAST IDX', lastIdx, 'FROM BEFORE?', (rowIndex > droppedItem.rowIndex));
                }
                XXX('DROP', "ON", rowIndex, aOrientation, "FROM ROW", droppedItem.rowIndex, "ADJUSTED", adjustedIndex, droppedItem.name);
                lastIdx = adjustedIndex;


                // Figure out if we are adding or reordering and do it
                XXX('IS FAV');
                if (isInParent && !this.isSorted(endParent)) {
                    XXX('IN PARENT', 'NOT SORTED');
                    flock.favorites.reorderItemInParent(droppedItem, endParent, adjustedIndex);
                }
                else if (!isInParent) {
                    XXX('NOT IN PARENT');
                    //dd(endParent);
                    if (this.isSorted(endParent)) {
                        flock.favorites.addItemToCollection(droppedItem, endParent);
                    }
                    else {
                        flock.favorites.addItemToCollection(droppedItem, endParent);
                        flock.favorites.reorderItemInParent(droppedItem, endParent, adjustedIndex + 1);
                    }
                }
                else {
                    XXX('IN PARENT', 'SORTED');
                }
                this.mNode.database.endUpdateBatch();
            }

        },/*}}}*/
        onSelectionChanged: function () {/*{{{*/
            //this.mNode.focus();
            //this.selectedItems = flock_getTreeSelection(this.mNode, ['url', 'name']);
            this.selectedItems = this.getSelected(['url','name']);
            flock_updateCommandset($('flock_favoriteCommands'));
        },/*}}}*/
        onPerformActionOnCell: function (aAction, aRow, aCol) {/*{{{*/
            switch (aAction) {
                case "onDblClick":
					switch (aCol) {
						case 'sharing':
							break;
						default:
							goDoCommand('cmd_favoriteMgrOpen');
							break;
					}
                    break;
                //case "onMdlClick":
                case "onDblCtrlClick":
                case "onDblMetaClick":
                    goDoCommand('cmd_favoriteMgrOpenInTab');
                    break;
            }
        },/*}}}*/
        onCycleCell: function (aRow, aCol) {/*{{{*/
            // ignore children
            if (this.getParentIndex(aRow) != -1) return;
            
            // privacy does not matter with no service
            if (!flock.favorites.service.webService()) return;

            // alright, get it
            var rsrc = this.getResourceAtIndex(aRow);
            var fav = flock.favorites.getFavorite(rsrc);
            fav.load();
            if (fav.local) {
                flock.favorites.editItem(fav, {local: false});
            }
            else {
                if (!fav.private && flock.favorites.supportsField('private')) {
                    flock.favorites.editItem(fav, {private: true});
                }
                else if (fav.private || !flock.favorites.supportsField('private')) {
                    flock.favorites.editItem(fav, {private: false, local: true});
                }
            }
            this.mNode.builder.rebuild();
        },/*}}}*/
    });
    favoritesTree.attach();
    favoriteDNDObserver.mTree = favoritesTree;

    // Context Menu
    var favContext = new flock.xul.SwitchingPopup($('favoriteContext'), {
        isDebug: false,
        popupSet: "favoriteContextPopupSet",
        onPopupShowing: function (aEvt) {/*{{{*/
            //tree.focus();
            flock_updateCommandset($('flock_favoriteCommands'));
            //XXX('localname', aEvt.explicitOriginalTarget.tagName);
            //dd(aEvt.explicitOriginalTarget);
            var count = tree.view.selection.count;
            if (aEvt.explicitOriginalTarget.tagName != "treechildren") {
                aEvt.preventDefault();
                return false;
            
            }
            
            if (count == 0) {
                aEvt.preventDefault();
                return false;
            }
            else if (count == 1) {
                this.switchTo("favoriteItemSelectedContext");
            }
            else {
                this.switchTo("favoriteMultipleItemsSelectedContext");
            }
            return true;
        },/*}}}*/
    });
    favContext.attach();
    
    // Searchbox
    var searchbox = $('favoritesManagerSearchbox');
    var searchboxObserver = {
            mOuter: this,
            mInput: searchbox,
            mTree: tree,
            mClearButton: $('favoritesManagerClearSearchbox'),
            mTreeTemplate: $('favoriteViewTemplate'),
            _searchResults: null,
            get searchResults() {/*{{{*/
                return this._searchResults;
            },/*}}}*/
            set searchResults(aDataSource) {/*{{{*/
                if (this._searchResults != null) {
                    flock.rdf.removeDataSources(this.mTree, 
                                                [this._searchResults]);
                }
                if (aDataSource == null) {
                    // we are clearing the tree
                    this.unfilterTree();
                    this._searchResults = null;
                    flock.xul.hide(this.mClearButton);
                }
                else {
                    flock.xul.show(this.mClearButton);
                    this._searchResults = aDataSource;
                    flock.rdf.addDataSources(this.mTree,
                                             [this._searchResults]);
                    this.filterTree();
                    dump_rdf(this._searchResults);
                }
                this.mTree.builder.rebuild();
            },/*}}}*/
            filterTree: function () {/*{{{*/
                // find all the conditions we need to add a rule to
                var searchConditions = document.getElementsByAttribute('favoritesSearch', 'conditions');
                for (var i = 0; i < searchConditions.length; i++) {
                    var conditions = searchConditions[i];
                    // XXX andy: i do not think we actually need to remove old filters,
                    //           they will get removed eventually via unfilterTree anyway
                    //           and i do not think they pose a more serious performance
                    //           threat than recursing over the items every time like
                    //           this could is doing.
                    //// find old search rules to remove
                    //for (var j = 0; j < conditions.childNodes.length; j++) {
                    //    var child = conditions.childNodes[j];
                    //    if (child.getAttribute ('predicate') == 
                    //            'http://flock.com/rdf#searchresult') {
                    //        // this is one we want to remove
                    //        conditions.removeChild (child);
                    //   }
                    //}
                    // create a rule to match only search results
                    var triple = flock.xul.createElement('triple', {
                        subject: "?uri",
                        predicate: "http://flock.com/rdf#searchresult",
                        object: "true",
                        favoritesSearch: "filter"   
                        
                    });

                    // and add it to the condition
                    conditions.appendChild(triple);
                }
            },/*}}}*/
            unfilterTree: function () {/*{{{*/
                // find all the filters we need to remove
                var searchFilters = document.getElementsByAttribute('favoritesSearch', 'filter');
                searchFilters = flock.lang.toArray(searchFilters);
                searchFilters.forEach(dojo.dom.removeNode);
            },/*}}}*/
            onEnter: function () {/*{{{*/
                if (this.mInput.value.length < this.mInput.minChars) {
                    this.unfilterTree();
                    this.searchResults = null;
                    return;
                }
                this.mInput.clearInputTimer();
                this.search();
            },/*}}}*/
            onEscape: function () {/*{{{*/
                XXX('onEscape');
                this.mInput.clear();
                this.mInput.clearInputTimer();
                this.searchResults = null;
            },/*}}}*/
            onInputDelayed: function (aEvent) {/*{{{*/
                XXX('SO VERY HAPPY TO BEH ERE');
                if (this.mInput.value.length < this.mInput.minChars) {
                    this.unfilterTree();
                    this.searchResults = null;
                    return;
                }
                this.search();
            },/*}}}*/
            search: function () {/*{{{*/
                XXX('SEARCHIPOO');
                var _this = this;
                var callback = new flock.search.SearchCallback({
                    onResult: function (aData) {
                        _this.searchResults = aData;
                    }
                });
                flock.search.search(this.mInput.value, 100, callback);
            },/*}}}*/

    }
    searchbox.addObserver(searchboxObserver);
    dojo.event.connect($('favoritesManagerClearSearchbox'), 'onclick',
                       searchboxObserver, 'onEscape');
    

    // handle initital query
    var qs = flock.browser.parseQuery(gBrowser.currentURI.spec);
    if (qs.filter) {
        searchbox.value = qs.filter;
        searchboxObserver.search();
    }
    
    tree.focus();
}
