// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


var gEngineItems;
var PREF = Components.classes["@mozilla.org/preferences-service;1"]
                   .getService(Components.interfaces.nsIPrefService)
                   .getBranch(null);

const EXCLUDED_ENGINES_PREF = 'flock.search.excludedEngines';
const DEFAULT_SEARCH_ENGINE = 'browser.search.defaultenginename';

function flock_enableDisableEngineSelection(aTarget) {
    var newVal = !aTarget.getAttribute('checked');
    for (var i =0; i < gEngineItems.length; i++)
        gEngineItems[i].setAttribute('disabled', newVal);
}

function flock_setupSearchPrefs() {
    gEngineItems = document.getElementsByAttribute('isSearchEngineItem', true);
    var excludedEngines = flock_getCharPref(EXCLUDED_ENGINES_PREF);
    for (var i =0; i < gEngineItems.length; i++) {
       if (excludedEngines.indexOf(gEngineItems[i].getAttribute('anonid')) != -1){
        gEngineItems[i].removeAttribute('checked');
       }
    }
    
    flock_setDefaultEnginePopup();
        
    $('flockDefaultSearchPopup').builder.rebuild();
}

function flock_saveSelectedEnginePrefs() {
    flock_setCharPref(EXCLUDED_ENGINES_PREF, '');
    var prefString = "";
    for (var i=0; i < gEngineItems.length; i++) {
        if (gEngineItems[i].checked == false)
            prefString = prefString + gEngineItems[i].getAttribute('anonid') + ',';
    }
    
    flock_setCharPref(EXCLUDED_ENGINES_PREF, prefString);
}

function flock_searchUpdatePref(aTarget) {
    flock_setBoolPref(aTarget.getAttribute('id'), aTarget.checked);
}

function flock_setDefaultEngine() {
    var selectedEngine = $('flockDefaultSearchMenu').selectedItem;
    flock_setCharPref(DEFAULT_SEARCH_ENGINE, selectedEngine.getAttribute('label'));
}

function flock_setDefaultEnginePopup() {
  var defaultEngineName = PREF.getComplexValue(DEFAULT_SEARCH_ENGINE,
                                     Components.interfaces.nsIPrefLocalizedString).data;


  for (var i =0; i < gEngineItems.length; i++)
    if (gEngineItems[i].getAttribute('label') == defaultEngineName)
      $('flockDefaultSearchMenu').selectedIndex = i+1; // This "+1" is required because of the dummy menuitem we have in the menulist
}
